# Copyright (c) 2007 The Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#   1. Redistributions of source code must retain the above copyright
#      notice, this list of conditions, and the following disclaimer.
#   2. Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions, and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
#   3. Redistributions must acknowledge that this software was
#      originally developed by the UCSF Computer Graphics Laboratory
#      under support by the NIH National Center for Research Resources,
#      grant P41-RR01081.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
# OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
# OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

from Tools import *

def xml_header(outf2,prot_name):
	line0 = """<?xml version="1.0"?>\n"""
	outf2.write(line0)
	line1 = "<!DOCTYPE TOPO [\n"
	outf2.write(line1)
	line2 = "\t<!ELEMENT TOPO (bbox, layout, membrane, zerobridge, entry*)>\n"
	outf2.write(line2)
	line2b = "\t<!ATTLIST TOPO name CDATA #REQUIRED>\n"
        outf2.write(line2b)
	line3 = "\t<!ELEMENT bbox EMPTY>\n"
	outf2.write(line3)
	line3b = "\t<!ATTLIST bbox minx CDATA #REQUIRED>\n"
	outf2.write(line3b)
	line3c = "\t<!ATTLIST bbox maxx CDATA #REQUIRED>\n"
	outf2.write(line3c)
	line3d = "\t<!ATTLIST bbox miny CDATA #REQUIRED>\n"
	outf2.write(line3d)
	line3e = "\t<!ATTLIST bbox maxy CDATA #REQUIRED>\n"
	outf2.write(line3e)
	line3f = "\t<!ATTLIST bbox rad CDATA #REQUIRED>\n"
	outf2.write(line3f)
	linex = "\t<!ELEMENT layout EMPTY>\n"
	outf2.write(linex)
	linex2 = "\t<!ATTLIST layout radius CDATA #REQUIRED>\n"
	outf2.write(linex2)
	linex3 = "\t<!ATTLIST layout label_top CDATA #REQUIRED>\n"
	outf2.write(linex3)
	linex4 = "\t<!ATTLIST layout label_bot CDATA #REQUIRED>\n"
	outf2.write(linex4)
	line4 = "\t<!ELEMENT membrane EMPTY>\n"
	outf2.write(line4)
	line4b = "\t<!ATTLIST membrane m_minx CDATA #REQUIRED>\n"
	outf2.write(line4b)
	line4c = "\t<!ATTLIST membrane m_maxx CDATA #REQUIRED>\n"
	outf2.write(line4c)
	line4d = "\t<!ATTLIST membrane m_topy CDATA #REQUIRED>\n"
	outf2.write(line4d)
	line4e = "\t<!ATTLIST membrane m_boty CDATA #REQUIRED>\n"
	outf2.write(line4e)
	line4x = "\t<!ELEMENT zerobridge EMPTY>\n"
	outf2.write(line4x)
	line4xb1 = "\t<!ATTLIST zerobridge b_start_x CDATA #REQUIRED>\n"
	outf2.write(line4xb1)
	line4xb2 = "\t<!ATTLIST zerobridge b_start_y CDATA #REQUIRED>\n"
	outf2.write(line4xb2)
	line4xc1 = "\t<!ATTLIST zerobridge b_ltop_x CDATA #REQUIRED>\n"
	outf2.write(line4xc1)
	line4xc2 = "\t<!ATTLIST zerobridge b_ltop_y CDATA #REQUIRED>\n"
	outf2.write(line4xc2)
	line4xd1 = "\t<!ATTLIST zerobridge b_rtop_x CDATA #REQUIRED>\n"
	outf2.write(line4xd1)
	line4xd2 = "\t<!ATTLIST zerobridge b_rtop_y CDATA #REQUIRED>\n"
	outf2.write(line4xd2)
	line4xe1 = "\t<!ATTLIST zerobridge b_end_x CDATA #REQUIRED>\n"
	outf2.write(line4xe1)
	line4xe2 = "\t<!ATTLIST zerobridge b_end_y CDATA #REQUIRED>\n"
	outf2.write(line4xe2)
	line4x = "\t<!ELEMENT feature EMPTY>\n"
	outf2.write(line4x)
	line4xb1 = "\t<!ATTLIST feature f_start_x CDATA #REQUIRED>\n"
	outf2.write(line4xb1)
	line4xb2 = "\t<!ATTLIST feature f_start_y CDATA #REQUIRED>\n"
	outf2.write(line4xb2)
	line4xc1 = "\t<!ATTLIST feature f_ltop_x CDATA #REQUIRED>\n"
	outf2.write(line4xc1)
	line4xc2 = "\t<!ATTLIST feature f_ltop_y CDATA #REQUIRED>\n"
	outf2.write(line4xc2)
	line4xd1 = "\t<!ATTLIST feature f_rtop_x CDATA #REQUIRED>\n"
	outf2.write(line4xd1)
	line4xd2 = "\t<!ATTLIST feature f_rtop_y CDATA #REQUIRED>\n"
	outf2.write(line4xd2)
	line4xe1 = "\t<!ATTLIST feature f_end_x CDATA #REQUIRED>\n"
	outf2.write(line4xe1)
	line4xe2 = "\t<!ATTLIST feature f_end_y CDATA #REQUIRED>\n"
	outf2.write(line4xe2)
	line5 = "\t<!ELEMENT entry EMPTY>\n"
	outf2.write(line5)
	line5b = "\t<!ATTLIST entry position CDATA #REQUIRED>\n"
	outf2.write(line5b)
	line5c = "\t<!ATTLIST entry residue CDATA #REQUIRED>\n"
	outf2.write(line5c)
	line5d = "\t<!ATTLIST entry x CDATA #REQUIRED>\n"
	outf2.write(line5d)
	line5e = "\t<!ATTLIST entry y CDATA #REQUIRED>\n"
	outf2.write(line5e)
	line5f = """\t<!ATTLIST entry symbol (0|1|2|3|4|5) "1">\n"""
	outf2.write(line5f)
	line5g = """\t<!ATTLIST entry foreground CDATA "0 0 0">\n"""
	outf2.write(line5g)
	line5h = """\t<!ATTLIST entry background CDATA "1 1 1">\n"""
	outf2.write(line5h)
	line5i = """\t<!ATTLIST entry border CDATA "0 0 0">\n"""
	outf2.write(line5i)
	line5j = "\t<!ATTLIST entry url CDATA #IMPLIED>\n"
	outf2.write(line5j)

	line9 = "]>\n"
	outf2.write(line9)
	line10 = """<TOPO name="%s">\n""" % (prot_name)
	outf2.write(line10)

	return

def xml_bbox(outf2,Minx,Maxx,Miny,Maxy):
	line1 = """\t<bbox minx="%f" maxx="%f" miny="%f" maxy="%f"/>\n""" % (Minx,Maxx,Miny,Maxy)
	outf2.write(line1)

	return

def xml_layout(outf2,R,TLABEL,BLABEL):
	line1 = """\t<layout radius="%f" label_top="%s" label_bot="%s"/>\n""" % (R,TLABEL,BLABEL)
	outf2.write(line1)

	return

def xml_mem(outf2,minx,maxx,yTop,yBot):
	line0 = """\t<membrane m_minx="%f" m_maxx="%f" m_topy="%f" m_boty="%f"/>\n""" % (minx,maxx,yTop,yBot)
	outf2.write(line0)
	
	return

def xml_bridge(outf2,b_start_x,b_start_y,b_ltop_x,b_ltop_y,b_rtop_x,b_rtop_y,b_end_x,b_end_y):
	line0 = """\t<zerobridge b_start_x="%f" b_start_y="%f" b_ltop_x="%f" b_ltop_y="%f" b_rtop_x="%f" b_rtop_y="%f" b_end_x="%f" b_end_y="%f"/>\n""" % (b_start_x,b_start_y,b_ltop_x,b_ltop_y,b_rtop_x,b_rtop_y,b_end_x,b_end_y)
	outf2.write(line0)
	
	return

def xml_feature(outf2,f_start_x,f_start_y,f_ltop_x,f_ltop_y,f_rtop_x,f_rtop_y,f_end_x,f_end_y):
	line0 = """\t<feature f_start_x="%f" f_start_y="%f" f_ltop_x="%f" f_ltop_y="%f" f_rtop_x="%f" f_rtop_y="%f" f_end_x="%f" f_end_y="%f"/>\n""" % (f_start_x,f_start_y,f_ltop_x,f_ltop_y,f_rtop_x,f_rtop_y,f_end_x,f_end_y)
	outf2.write(line0)
	
	return

def xml_data_tail(outf2):
	line1 = "</TOPO>\n"
	outf2.write(line1)

	return

def xml_data_line(outf2,l1,l2,l3,l4,l5,l6,no):
	#print "l5 is %d" % l5
        if no == 1:
           l2 = " "
	if l5 == 0:
		cols = colors(l6)
		fore = cols[1]
		back2 = "1 1 1"
		border2 = "1 1 1"
		line0 = """\t<entry position="%d" residue="%s" x="%f" y="%f" symbol="%d" foreground="%s" background="%s" border="%s"/>\n""" % (l1,l2,l3,l4,l5,fore,back2,border2)
	elif l5 == 1 and l6 == "x":
		line0 = """\t<entry position="%d" residue="%s" x="%f" y="%f" foreground="0 0 0" background="1 1 1" border="0 0 0"/>\n""" % (l1,l2,l3,l4)
	else:
		cols = colors(l6)
		fore = cols[0]
		back = cols[1]
		border = cols[2]
		line0 = """\t<entry position="%d" residue="%s" x="%f" y="%f" symbol="%d" foreground="%s" background="%s" border="%s"/>\n""" % (l1,l2,l3,l4,l5,fore,back,border)
	outf2.write(line0)

	return

